#ifndef qt_CLASSLOAD_HPP_INCLUDED
#define qt_CLASSLOAD_HPP_INCLUDED 1

#include <s11n.net/s11n/classload.hpp>

class QWidget;

namespace s11n { namespace qt {


        template <typename QWT>
        struct widget_factory
        {
                static QWidget * factory()
                {
                        //CERR << "Default QWidget factory!\n";
                        return new QWT( 0, 0 );
                }
        };

        /**
           WidgetT must subclass QWidget.
        */
        template <typename WidgetT>
        void register_widget( const std::string & classname )
        {
                //CERR << "register_widget("<<classname<<")\n";
                s11n::cl::classloader_register<QWidget,WidgetT>( classname,
								 widget_factory<WidgetT>::factory );
        }

        
        /**
           Returns a new widget, or 0 on error. Caller owns the
           returned pointer.

           Can load any widgets registered with cllite's QWidget
           classloader.
        */
        QWidget * create_widget( const std::string & classname );


} } // namespace s11n::qt


#endif // qt_CLASSLOAD_HPP_INCLUDED
