/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <s11n.net/s11n/s11nlite.hpp>
#include <s11n.net/s11n/io/serializers.hpp> // serializer_list()
#include <s11n.net/s11n/s11n_debuggering_macros.hpp>
#include <s11n.net/zfstream/zfstream.hpp>

#include <qstringlist.h>

void SerializerConfigDialog::init()
{
    this->updateSerializerLists( this->checkBoxHideLong->isChecked() );
    this->textSerializerNotes->setShown( toggleShowNotes->isOn() );
    QComboBox * cb = this->comboCompression;
    cb->setCurrentItem( static_cast<int>( zfstream::compression_policy() ) );
}

void SerializerConfigDialog::accept()
{
    QComboBox * cb = this->comboCompression;
    zfstream::compression_policy(
	    static_cast<zfstream::CompressionPolicy>( cb->currentItem() ) );
    s11nlite::serializer_class( this->listOutputs->currentText() );
    this->QDialog::accept();
}


void SerializerConfigDialog::updateSerializerLists( bool hideLongNames )
{
    QStringList slist;
    QString currentOut =  s11nlite::serializer_class();
    
    s11n::io::serializer_list<s11nlite::node_type>( slist, hideLongNames );
    QStringList::const_iterator b = slist.begin(), e = slist.end();
    int ndx = -1;
    for( ; e != b; ++b )
    {
	++ndx;
	if( (*b) == currentOut ) break;
    }
    this->listOutputs->clear();
    this->listOutputs->insertStringList( slist, -1 );
    this->listOutputs->setCurrentItem( ndx );
}


void SerializerConfigDialog::setSerializer( const QString & classname )
{
    s11nlite::serializer_class( classname );
}


